# -*- coding: utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution
#    Copyright (C) 2004-2010 Tiny SPRL (<http://tiny.be>).
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Affero General Public License as
#    published by the Free Software Foundation, either version 3 of the
#    License, or (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Affero General Public License for more details.
#
#    You should have received a copy of the GNU Affero General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################

from osv import fields,osv

class res_partner_address(osv.osv):
    _description ='Partner Addresses'
    _name = 'res.partner.address'
    _inherit = 'res.partner.address'

    _order = 'type, name'
    _columns = {
        'postcode_id': fields.many2one('res.postcodes', 'Postcode', ondelete='set null', select=True, help="Keep empty for a private address, not related to partner."),
        'postcode':    fields.char('Postcode', size=5, help=""),
        'street':      fields.char('Street', size=25, help=""),
        'city':        fields.char('City', size=25, help=""),
        'county':      fields.char('County', size=25, help=""),
        'municipal':   fields.char('Municipal', size=25, help=""),
    }

    def onchange_postcode(self, cr, uid, ids, postcode, city, street):
        return self.pool.get('res.postcodes').onchange_postcode(cr,uid,ids,postcode,city,street)

    def onchange_street(self, cr, uid, ids, postcode, city, street):
        return self.pool.get('res.postcodes').onchange_street(cr,uid,ids,postcode,city,street)


res_partner_address()



# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:
