# -*- encoding: utf-8 -*-
##############################################################################
#
#    Addition to OpenERP, Open Source Management Solution   
#    Copyright (C) 2012 Vertel. All Rights Reserved
#    $Id$
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################

from osv import fields,osv
import re

class res_postcodes(osv.osv):
    _description ='Swedish postcodes'
    _name = 'res.postcodes'

#    _order = 'postcode, street, city'
    
    _columns = {
        'postcode':    fields.char('Postcode', size=5, help=""),
        'street':      fields.char('Street', size=25, help=""),
        'street_from': fields.char('Streetno from', size=3,help="Interval where this postcode is relevant, it can be odd or even numbers in intervals or both"),
        'street_to':   fields.char('Streetno to', size=3,help="Interval where this postcode is relevant"),
        'city':        fields.char('City', size=25, help=""),
        'countyno':    fields.char('County No', size=2, help=""),
        'county':      fields.char('County', size=25, help=""),
        'municipalno': fields.char('Municipal No', size=5, help=""),
        'municipal':   fields.char('Municipal', size=25, help=""),
    }


    def onchange_postcode(self, cr, uid, ids, postcode, city, street):
        result = {
                  'municipal': '',
                  'county': '',
                  'city': city,
          }

        pc = self.pool.get('res.postcodes')
        postcode_obj = pc.browse(cr,uid,pc.search(cr,uid,[('postcode','=',postcode)]))

        if postcode_obj:
            if postcode_obj[0].city:
                result['city']      = postcode_obj[0].city
                result['municipal'] = postcode_obj[0].municipal
                result['county']    = postcode_obj[0].county


        return {'value': result}

    def onchange_street(self, cr, uid, ids, postcode, city, street):
        result = {
                  'street': street,
                  'city': city,
                  'postcode': postcode,
                  'municipal': '',
                  'county': '',
          }

        try:
            (name,no,rem) = re.split(' ([0-9]+\w*)',street) 
        except:
            name = street
            no = ''
            
        pc = self.pool.get('res.postcodes')
        if not city:
            city = ''
        if not postcode:
            postcode = ''
        postcode_obj = pc.browse(cr,uid,pc.search(cr,uid,['&','&',('street','ilike','%s%%' % name),('city','ilike','%%%s%%' % city),('postcode','ilike','%%%s%%' % postcode)]))
 
        if postcode_obj:
            if postcode_obj[0].city:
                result['street'] = "%s %s" % (postcode_obj[0].street,no) 
                result['postcode'] = postcode_obj[0].postcode
                result['city'] = postcode_obj[0].city
                result['municipal'] = postcode_obj[0].municipal
                result['county'] = postcode_obj[0].county

        return {'value': result}

res_postcodes()

# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:
